diff -urN linux.store/linux/arch/arm/lib/io.S linux/arch/arm/lib/io.S
--- linux.store/linux/arch/arm/lib/io.S	Wed Mar 13 23:55:08 1996
+++ linux/arch/arm/lib/io.S	Thu Mar 28 10:11:19 1996
@@ -100,9 +100,9 @@
 		orrlt	r3, r3, #0x00010000
 		add	r0, r3, r0, lsl #2
 		tst	r1, #3
-		beq	pcinswok
+		beq	Linswok
 		tst	r1, #1
-		bne	pcinsw_notaligned
+		bne	Linsw_notaligned
 		cmp	r2, #1
 		ldrge	r4, [r0]
 		strgeb	r4, [r1], #1
@@ -110,10 +110,10 @@
 		strgtb	r4, [r1], #1
 		ldmleea	fp, {r4 - r10, fp, sp, pc}^
 		sub	r2, r2, #2
-pcinswok:	mov	ip, #0xFF
+Linswok:	mov	ip, #0xFF
 		orr	ip, ip, ip, lsl #8
-pcinswlp:	subs	r2, r2, #64
-		bmi	pcinsw_toosmall
+Linswlp:	subs	r2, r2, #64
+		bmi	Linsw_toosmall
 		IN(r3)
 		IN(r4)
 		IN(r5)
@@ -132,12 +132,12 @@
 		IN(r9)
 		IN(r10)
 		stmia	r1!, {r3 - r10}
-		bne	pcinswlp
+		bne	Linswlp
 		LOADREGS(ea, fp, {r4 - r10, fp, sp, pc})
-pcinsw_toosmall:
+Linsw_toosmall:
 		add	r2, r2, #32
-		bmi	pcinsw_toosmall2
-pcinsw2lp:	IN(r3)
+		bmi	Linsw_toosmall2
+Linsw2lp:	IN(r3)
 		IN(r4)
 		IN(r5)
 		IN(r6)
@@ -147,10 +147,10 @@
 		IN(r10)
 		stmia	r1!, {r3 - r10}
 		LOADREGS(eqea, fp, {r4 - r10, fp, sp, pc})
-		b	pcinsw_notaligned
-pcinsw_toosmall2:
+		b	Linsw_notaligned
+Linsw_toosmall2:
 		add	r2, r2, #32
-pcinsw_notaligned:
+Linsw_notaligned:
 		cmp	r2, #1
 		LOADREGS(ltea, fp, {r4 - r10, fp, sp, pc})
 		ldr	r4, [r0]
@@ -158,7 +158,7 @@
 		movgt	r4, r4, LSR#8
 		strgtb	r4, [r1], #1
 		subs	r2, r2, #2
-		bgt	pcinsw_notaligned
+		bgt	Linsw_notaligned
 		LOADREGS(ea, fp, {r4 - r10, fp, sp, pc})
 
 @ Purpose: write a block of data from memory to a hardware register.
@@ -177,7 +177,7 @@
 		movlt	r3, #0x03000000
 		orrlt	r3, r3, #0x00010000
 		tst	r1, #2
-		beq	pcoutsw32lp
+		beq	Loutsw32lp
 		ldr	r4, [r1], #2
 		mov	r4, r4, lsl #16
 		orr	r4, r4, r4, lsr #16
@@ -185,8 +185,8 @@
 		sub	r2, r2, #2
 		teq	r2, #0
 		LOADREGS(eqea, fp, {r4 - r8, fp, sp, pc})
-pcoutsw32lp:	subs	r2,r2,#32
-		blt	pcoutsw_toosmall
+Loutsw32lp:	subs	r2,r2,#32
+		blt	Loutsw_toosmall
 		ldmia	r1!,{r4,r5,r6,r7}
 		OUT(r4)
 		OUT(r5)
@@ -198,16 +198,16 @@
 		OUT(r6)
 		OUT(r7)
 		LOADREGS(eqea, fp, {r4 - r8, fp, sp, pc})
-		b	pcoutsw32lp
-pcoutsw_toosmall:
+		b	Loutsw32lp
+Loutsw_toosmall:
 		adds	r2,r2,#32
 		LOADREGS(eqea, fp, {r4 - r8, fp, sp, pc})
-lpx:		ldr	r4,[r1],#2
+Llpx:		ldr	r4,[r1],#2
 		mov	r4,r4,LSL#16
 		orr	r4,r4,r4,LSR#16
 		str	r4,[r3,r0,LSL#2]
 		subs	r2,r2,#2
-		bgt	lpx
+		bgt	Llpx
 		LOADREGS(ea, fp, {r4 - r8, fp, sp, pc})
 
 @ Purpose: write a vidc register.
diff -urN linux.store/linux/arch/arm/lib/iputils.S linux/arch/arm/lib/iputils.S
--- linux.store/linux/arch/arm/lib/iputils.S	Sun Mar  3 13:14:06 1996
+++ linux/arch/arm/lib/iputils.S	Thu Mar 28 10:15:10 1996
@@ -11,19 +11,19 @@
 @ r2 = sum
 		.global	_csum_partial
 _csum_partial:	tst	r0, #2
-		beq	alignok
+		beq	Lalignok
 		subs	r1, r1, #2
 		addmi	r1, r1, #2
-		bmi	nobits32
+		bmi	Lnobits32
 		bic	r0, r0, #3
 		ldr	r3, [r0], #4
 		adds	r2, r2, r3, lsr #16
 		adcs	r2, r2, #0
-alignok:	adds	r2, r2, #0
+Lalignok:	adds	r2, r2, #0
 		bics	ip, r1, #31
-		beq	nolots32
+		beq	Lnolots32
 		stmfd	sp!, {r4 - r10}
-lp32:		ldmia	r0!, {r3 - r10}
+Llp32:		ldmia	r0!, {r3 - r10}
 		adcs	r2, r2, r3
 		adcs	r2, r2, r4
 		adcs	r2, r2, r5
@@ -34,18 +34,18 @@
 		adcs	r2, r2, r10
 		sub	ip, ip, #32
 		teq	ip, #0
-		bne	lp32
+		bne	Llp32
 		adcs	r2, r2, #0
 		ldmfd	sp!, {r4 - r10}
-nolots32:	ands	ip, r1, #0x1c
-		beq	nobits32
-bits32lp:	ldr	r3, [r0], #4
+Lnolots32:	ands	ip, r1, #0x1c
+		beq	Lnobits32
+Lbits32lp:	ldr	r3, [r0], #4
 		adcs	r2, r2, r3
 		sub	ip, ip, #4
 		teq	ip, #0
-		bne	bits32lp
+		bne	Lbits32lp
 		adcs	r2, r2, #0
-nobits32:	ands	ip, r1, #3
+Lnobits32:	ands	ip, r1, #3
 		moveq	r0, r2
 		moveqs	pc, lr
 		mov	ip, ip, lsl #3
@@ -66,10 +66,10 @@
 		stmfd	sp!, {r4 - r10, fp, ip, lr, pc}
 		sub	fp, ip, #4
 		tst	r1, #2			@ Test destination alignment
-		beq	dst_aligned
+		beq	Ldst_aligned
 		subs	r2, r2, #2
 		addmi	r2, r2, #2
-		bmi	nobits32_b
+		bmi	Lnobits32_b
 		ldrt	r4, [r0], #2
 		mov	r5, r4, lsl #16
 		adds	r3, r3, r5, lsr #16
@@ -77,12 +77,12 @@
 		strb	r4, [r1], #1
 		mov	r4, r4, lsr #8
 		strb	r4, [r1], #1		@ Destination now aligned
-dst_aligned:	tst	r0, #2
-		bne	src_not_aligned
+Ldst_aligned:	tst	r0, #2
+		bne	Lsrc_not_aligned
 		adds	r3, r3, #0
 		bics	ip, r2, #31		@ Routine for src & dst aligned
-		beq	nolots32_ba
-lp32_ba:	ldrt	r4, [r0], #4
+		beq	Lnolots32_ba
+Llp32_ba:	ldrt	r4, [r0], #4
 		ldrt	r5, [r0], #4
 		ldrt	r6, [r0], #4
 		ldrt	r7, [r0], #4
@@ -108,20 +108,20 @@
 		adcs	r3, r3, r7
 		sub	ip, ip, #32
 		teq	ip, #0
-		bne	lp32_ba
+		bne	Llp32_ba
 		adcs	r3, r3, #0
-nolots32_ba:	ands	ip, r2, #0x1c
-		beq	nobits32_ba
-bits32lp_ba:	ldrt	r4, [r0], #4
+Lnolots32_ba:	ands	ip, r2, #0x1c
+		beq	Lnobits32_ba
+Lbits32lp_ba:	ldrt	r4, [r0], #4
 		str	r4, [r1], #4
 		adcs	r3, r3, r4
 		sub	ip, ip, #4
 		teq	ip, #0
-		bne	bits32lp_ba
+		bne	Lbits32lp_ba
 		adcs	r3, r3, #0
-nobits32_ba:	ands	ip, r2, #3
+Lnobits32_ba:	ands	ip, r2, #3
 		moveq	r0, r3
-		beq	alldone_ba
+		beq	Lalldone_ba
 		mov	r5, ip, lsl #3
 		rsb	r5, r5, #32
 		ldr	r4, [r0]
@@ -136,16 +136,16 @@
 		teq	ip, #3
 		moveq	r4, r4, lsr #8
 		streqb	r4, [r1], #1
-alldone_ba:	ldmea	fp, {r4 - r10, fp, sp, pc}^
+Lalldone_ba:	ldmea	fp, {r4 - r10, fp, sp, pc}^
 
-src_not_aligned:
+Lsrc_not_aligned:
 		cmp	r2, #4
 		bic	r0, r0, #3
 		ldrcst	r4, [r0], #4
 		adds	r3, r3, #0
 		bics	ip, r2, #31
-		beq	notlots32_b
-lp32_b:		ldrt	r5, [r0], #4
+		beq	Lnotlots32_b
+Llp32_b:	ldrt	r5, [r0], #4
 		ldrt	r6, [r0], #4
 		ldrt	r7, [r0], #4
 		ldrt	r8, [r0], #4
@@ -183,11 +183,11 @@
 		mov	r4, r8
 		sub	ip, ip, #32
 		teq	ip, #0
-		bne	lp32_b
+		bne	Llp32_b
 		adcs	r3, r3, #0
-notlots32_b:	ands	ip, r2, #0x1c
-		beq	nobits32_b
-bits32lp_b:	ldrt	r5, [r0], #4
+Lnotlots32_b:	ands	ip, r2, #0x1c
+		beq	Lnobits32_b
+Lbits32lp_b:	ldrt	r5, [r0], #4
 		mov	r4, r4, lsr #16
 		orr	r4, r4, r5, lsl #16
 		str	r4, [r1], #4
@@ -195,11 +195,11 @@
 		mov	r4, r5
 		sub	ip, ip, #4
 		teq	ip, #0
-		bne	bits32lp_b
+		bne	Lbits32lp_b
 		adc	r3, r3, #0
-nobits32_b:	ands	ip, r2, #3
+Lnobits32_b:	ands	ip, r2, #3
 		moveq	r0, r3
-		beq	alldone_b
+		beq	Lalldone_b
 		ldrt	r5, [r0], #4
 		mov	r4, r4, lsr #16
 		orr	r4, r4, r5, lsl #16
@@ -216,7 +216,7 @@
 		teq	ip, #3
 		moveq	r4, r4, lsr #8
 		streqb	r4, [r1], #1
-alldone_b:	ldmea	fp, {r4 - r10, fp, sp, pc}^
+Lalldone_b:	ldmea	fp, {r4 - r10, fp, sp, pc}^
 
 
 @ r0 = src
@@ -229,10 +229,10 @@
 		stmfd	sp!, {r4 - r10, fp, ip, lr, pc}
 		sub	fp, ip, #4
 		tst	r1, #2			@ Test destination alignment
-		beq	dst_aligned_2
+		beq	Ldst_aligned_2
 		subs	r2, r2, #2
 		addmi	r2, r2, #2
-		bmi	nobits32_b_2
+		bmi	Lnobits32_b_2
 		ldr	r4, [r0], #2
 		mov	r5, r4, lsl #16
 		adds	r3, r3, r5, lsr #16
@@ -240,12 +240,12 @@
 		strb	r4, [r1], #1
 		mov	r4, r4, lsr #8
 		strb	r4, [r1], #1		@ Destination now aligned
-dst_aligned_2:	tst	r0, #2
-		bne	src_not_aligned_2
+Ldst_aligned_2:	tst	r0, #2
+		bne	Lsrc_not_aligned_2
 		adds	r3, r3, #0
 		bics	ip, r2, #31		@ Routine for src & dst aligned
-		beq	nolots32_ba_2
-lp32_ba_2:	ldr	r4, [r0], #4
+		beq	Lnolots32_ba_2
+Llp32_ba_2:	ldr	r4, [r0], #4
 		ldr	r5, [r0], #4
 		ldr	r6, [r0], #4
 		ldr	r7, [r0], #4
@@ -271,20 +271,20 @@
 		adcs	r3, r3, r7
 		sub	ip, ip, #32
 		teq	ip, #0
-		bne	lp32_ba_2
+		bne	Llp32_ba_2
 		adcs	r3, r3, #0
-nolots32_ba_2:	ands	ip, r2, #0x1c
-		beq	nobits32_ba_2
-bits32lp_ba_2:	ldr	r4, [r0], #4
+Lnolots32_ba_2:	ands	ip, r2, #0x1c
+		beq	Lnobits32_ba_2
+Lbits32lp_ba_2:	ldr	r4, [r0], #4
 		str	r4, [r1], #4
 		adcs	r3, r3, r4
 		sub	ip, ip, #4
 		teq	ip, #0
-		bne	bits32lp_ba_2
+		bne	Lbits32lp_ba_2
 		adcs	r3, r3, #0
-nobits32_ba_2:	ands	ip, r2, #3
+Lnobits32_ba_2:	ands	ip, r2, #3
 		moveq	r0, r3
-		beq	alldone_ba_2
+		beq	Lalldone_ba_2
 		mov	r5, ip, lsl #3
 		rsb	r5, r5, #32
 		ldr	r4, [r0]
@@ -299,16 +299,16 @@
 		teq	ip, #3
 		moveq	r4, r4, lsr #8
 		streqb	r4, [r1], #1
-alldone_ba_2:	ldmea	fp, {r4 - r10, fp, sp, pc}^
+Lalldone_ba_2:	ldmea	fp, {r4 - r10, fp, sp, pc}^
 
-src_not_aligned_2:
+Lsrc_not_aligned_2:
 		cmp	r2, #4
 		bic	r0, r0, #3
 		ldrcs	r4, [r0], #4
 		adds	r3, r3, #0
 		bics	ip, r2, #31
-		beq	notlots32_b_2
-lp32_b_2:	ldr	r5, [r0], #4
+		beq	Lnotlots32_b_2
+Llp32_b_2:	ldr	r5, [r0], #4
 		ldr	r6, [r0], #4
 		ldr	r7, [r0], #4
 		ldr	r8, [r0], #4
@@ -346,11 +346,11 @@
 		mov	r4, r8
 		sub	ip, ip, #32
 		teq	ip, #0
-		bne	lp32_b_2
+		bne	Llp32_b_2
 		adcs	r3, r3, #0
-notlots32_b_2:	ands	ip, r2, #0x1c
-		beq	nobits32_b_2
-bits32lp_b_2:	ldr	r5, [r0], #4
+Lnotlots32_b_2:	ands	ip, r2, #0x1c
+		beq	Lnobits32_b_2
+Lbits32lp_b_2:	ldr	r5, [r0], #4
 		mov	r4, r4, lsr #16
 		orr	r4, r4, r5, lsl #16
 		str	r4, [r1], #4
@@ -358,11 +358,11 @@
 		mov	r4, r5
 		sub	ip, ip, #4
 		teq	ip, #0
-		bne	bits32lp_b_2
+		bne	Lbits32lp_b_2
 		adcs	r3, r3, #0
-nobits32_b_2:	ands	ip, r2, #3
+Lnobits32_b_2:	ands	ip, r2, #3
 		moveq	r0, r3
-		beq	alldone_b_2
+		beq	Lalldone_b_2
 		ldr	r5, [r0], #4
 		mov	r4, r4, lsr #16
 		orr	r4, r4, r5, lsl #16
@@ -379,7 +379,4 @@
 		teq	ip, #3
 		moveq	r4, r4, lsr #8
 		streqb	r4, [r1], #1
-alldone_b_2:	ldmea	fp, {r4 - r10, fp, sp, pc}^
-
-
-
+Lalldone_b_2:	ldmea	fp, {r4 - r10, fp, sp, pc}^
diff -urN linux.store/linux/arch/arm/lib/ll_char_wr.S linux/arch/arm/lib/ll_char_wr.S
--- linux.store/linux/arch/arm/lib/ll_char_wr.S	Wed Mar 13 23:55:08 1996
+++ linux/arch/arm/lib/ll_char_wr.S	Thu Mar 28 10:15:50 1996
@@ -55,8 +55,8 @@
 		mul	r6, r5, r6
 		mov	r1, r1, lsl #3
 		teq	r5, #8
-		beq	row8bpplp
-row4bpplp:
+		beq	Lrow8bpplp
+Lrow4bpplp:
 		ldrb	r9, [r7, r1]
 		and	r8, r1, #7
 		teq	r8, #7
@@ -91,10 +91,10 @@
 		str	ip, [r0], r6
 		add	r1, r1,#1
 		tst	r1, #7
-		bne	row4bpplp
+		bne	Lrow4bpplp
 		LOADREGS(ea, fp, {r4 - r9, fp, sp, pc})
 
-row8bpplp:	ldrb	r9, [r7, r1]
+Lrow8bpplp:	ldrb	r9, [r7, r1]
 		and	r8, r1, #7
 		teq	r8, #7
 		tsteq	r4, #UNDERLINE << 24
@@ -127,6 +127,6 @@
 		add	r0, r0, r6
 		add	r1,r1,#1
 		tst	r1,#7
-		bne	row8bpplp
+		bne	Lrow8bpplp
 		LOADREGS(ea, fp, {r4 - r9, fp, sp, pc})
 
diff -urN linux.store/linux/arch/arm/lib/memfastset.S linux/arch/arm/lib/memfastset.S
--- linux.store/linux/arch/arm/lib/memfastset.S	Sun Mar  3 13:15:54 1996
+++ linux/arch/arm/lib/memfastset.S	Thu Mar 28 10:16:22 1996
@@ -12,8 +12,9 @@
 
 _memfastset:	stmfd	sp!, {lr}
 		subs	r2, r2, #32
-		bmi	memfastl32
-memfast32setlp:	str	r1, [r0], #4
+		bmi	Lmemfastl32
+Lmemfast32setlp:
+		str	r1, [r0], #4
 		str	r1, [r0], #4
 		str	r1, [r0], #4
 		str	r1, [r0], #4
@@ -23,18 +24,19 @@
 		str	r1, [r0], #4
 		LOADREGS(eqfd, sp!, {pc})
 		subs	r2, r2, #32
-		bpl	memfast32setlp
-memfastl32:	adds	r2, r2, #16
-		bmi	memfastl16
-memfast16setlp:	str	r1, [r0], #4
+		bpl	Lmemfast32setlp
+Lmemfastl32:	adds	r2, r2, #16
+		bmi	Lmemfastl16
+Lmemfast16setlp:
+		str	r1, [r0], #4
 		str	r1, [r0], #4
 		str	r1, [r0], #4
 		str	r1, [r0], #4
 		LOADREGS(eqfd, sp!, {pc})
 		subs	r2, r2, #16
-		bpl	memfast16setlp
-memfastl16:	add	r2, r2, #16
-memfastsetlp:	subs	r2, r2, #4
+		bpl	Lmemfast16setlp
+Lmemfastl16:	add	r2, r2, #16
+Lmemfastsetlp:	subs	r2, r2, #4
 		strge	r1, [r0], #4
-		bgt	memfastsetlp
+		bgt	Lmemfastsetlp
 		LOADREGS(fd, sp!, {pc})
diff -urN linux.store/linux/arch/arm/lib/mfm.S linux/arch/arm/lib/mfm.S
--- linux.store/linux/arch/arm/lib/mfm.S	Wed Mar 13 23:55:08 1996
+++ linux/arch/arm/lib/mfm.S	Thu Mar 28 14:23:22 1996
@@ -38,7 +38,6 @@
   adr r5,_hdc63463_irqdata
   ldmia r5,{r0,r1,r2,r3,r4}
 
-writedma_loop:
   @ test number of remaining bytes to transfer
   cmp r4,#0
   beq writedma_end
@@ -49,6 +48,11 @@
   tst r5,r2
   beq writedma_end
 
+  @ Transfer a block of upto 256 bytes
+  cmp r4,#256
+  movlt r7,r4
+  movge r7,#256
+
   @ Check the hdc is still busy and command has not ended and no errors
   ldr r5,[r0,#32]     @ Status reg - 16 bit - its the top few bits which are status
   tst r5,#0x3c00        @ Test for things which should be off
@@ -57,6 +61,10 @@
   cmp r5,#0x8000
   bne writedma_end 
 
+  @ Bytes remaining at end
+  sub r4,r4,r7
+
+writedma_loop:
   @ OK - pretty sure we should be doing this
   @ Get two bytes - note it can be half word aligned; its easiest to read 2 bytes
   ldrb r6,[r3],#1
@@ -64,8 +72,8 @@
   orr  r6,r6,r5,lsl#8  @ Put them together, note big endian for HDC
   orr  r6,r6,r6,lsl#16    @ Both halves of word for podule write
   str  r6,[r0,#32+8]      @ Put the data out
-  subs r4,r4,#2        @ Decrement bytes to go
-  b writedma_loop
+  subs r7,r7,#2        @ Decrement bytes to go
+  bne writedma_loop
 
 writedma_end:
   adr r5,_hdc63463_irqdata+12
@@ -83,7 +91,6 @@
   adr r5,_hdc63463_irqdata
   ldmia r5,{r0,r1,r2,r3,r4}
 
-readdma_loop:
   @ test number of remaining bytes to transfer
   cmp r4,#0
   beq readdma_end
@@ -102,14 +109,23 @@
   cmp r5,#0x8000
   bne readdma_end 
 
+  @ Transfer a block of upto 256 bytes
+  cmp r4,#256
+  movlt r7,r4
+  movge r7,#256
+
+  @ Bytes remaining at end
+  sub r4,r4,r7
+
+readdma_loop:
   @ OK - pretty sure we should be doing this
   @ Get two bytes - note it can be half word aligned; its easiest to read 2 bytes
-  ldr  r6,[r0,#8]     @ Read data from hdc - its in the bottom half
+  ldr  r6,[r0,#8]      @ Read data from hdc - its in the bottom half
   mov  r5,r6,lsr#8     @ Move second byte to bottom
   strb r6,[r3],#1      @ Note endian swap in here
   strb r5,[r3],#1
-  subs r4,r4,#2        @ Decrement bytes to go
-  b readdma_loop
+  subs r7,r7,#2        @ Decrement bytes to go
+  bne readdma_loop
 
 readdma_end:
   adr r5,_hdc63463_irqdata+12
diff -urN linux.store/linux/arch/arm/lib/prints.S linux/arch/arm/lib/prints.S
--- linux.store/linux/arch/arm/lib/prints.S	Sun Mar  3 13:16:21 1996
+++ linux/arch/arm/lib/prints.S	Thu Mar 28 10:17:07 1996
@@ -22,19 +22,19 @@
 		mov	r2, #0x03000000
 		orr	r2, r2, #0x00010000
 		orr	r2, r2, #0x00000fe0
-outlp:		ldrb	r1, [r0], #1
+Loutlp:		ldrb	r1, [r0], #1
 		teq	r1, #0
-		beq	out
+		beq	Lout
 		teq	r1, #10
 		moveq	r3, #13
 		streqb	r3, [r0, #-1]!
 		strb	r1, [r2]
 		mov	r3, #0x8000
-dlylp:		sub	r3, r3, #1
+Ldlylp:		sub	r3, r3, #1
 		teq	r3, #0
-		bne	dlylp
-		b	outlp
-out:		LOADREGS(ea, fp, {fp, sp, pc})
+		bne	Ldlylp
+		b	Loutlp
+Lout:		LOADREGS(ea, fp, {fp, sp, pc})
 
 		.global	_prints
 _prints:	mov	ip, sp
@@ -43,16 +43,16 @@
 		mov	r2, #0x03000000
 		orr	r2, r2, #0x00010000
 		orr	r2, r2, #0x00000fe0
-out2lp:		LDRB	r1, [r0], #1
+Lout2lp:	LDRB	r1, [r0], #1
 		TEQ	r1, #0
-		BEQ	out
+		BEQ	Lout
 		TEQ	r1, #10
 		MOVEQ	r3, #13
 		STREQB	r3, [r0, #-1]!
 		STRB	r1, [r2]
 		MOV	r3, #0x8000
-dly2lp:		SUB	r3, r3, #1
+Ldly2lp:	SUB	r3, r3, #1
 		TEQ	r3, #0
-		BNE	dly2lp
-		B	out2lp
+		BNE	Ldly2lp
+		B	Lout2lp
 
diff -urN linux.store/linux/arch/arm/lib/segment.S linux/arch/arm/lib/segment.S
--- linux.store/linux/arch/arm/lib/segment.S	Sun Mar  3 13:20:42 1996
+++ linux/arch/arm/lib/segment.S	Thu Mar 28 10:30:46 1996
@@ -90,17 +90,17 @@
 		bge	_memcpy_fromfs
 		ENTER
 		subs	r2, r2, #4
-		blt	no_double_words
+		blt	Lno_double_words
 		ands	ip, r0, #3
-		bne	dest_not_aligned
+		bne	Ldest_not_aligned
 		ands	ip, r1, #3
-		bne	src_not_aligned
-rest:		subs	r2, r2, #8
-		blt	cpy_2_lp
+		bne	Lsrc_not_aligned
+Lrest:		subs	r2, r2, #8
+		blt	Lcpy_2_lp
 		subs	r2, r2, #0x14
-		blt	not_long_copy
+		blt	Lnot_long_copy
 
-cpy_8_lp:	ldmia	r1!, {r3 - r9, ip}
+Lcpy_8_lp:	ldmia	r1!, {r3 - r9, ip}
 		strt	r3, [r0], #4
 		strt	r4, [r0], #4
 		strt	r5, [r0], #4
@@ -110,7 +110,7 @@
 		strt	r9, [r0], #4
 		strt	ip, [r0], #4
 		subs	r2, r2, #32
-		bge	cpy_8_lp
+		bge	Lcpy_8_lp
 		cmn	r2,#16
 		ldmgeia	r1!,{r3 - r6}
 		strget	r3, [r0], #4
@@ -119,17 +119,17 @@
 		strget	r6, [r0], #4
 		subge	r2, r2, #0x10
 
-not_long_copy:	adds	r2,r2,#0x14
+Lnot_long_copy:	adds	r2,r2,#0x14
 
-cpy_3_lp:	ldmgeia	r1!, {r3 - r5}
+Lcpy_3_lp:	ldmgeia	r1!, {r3 - r5}
 		strget	r3, [r0], #4
 		strget	r4, [r0], #4
 		strget	r5, [r0], #4
 		subges	r2, r2, #12
-		bge	cpy_3_lp
+		bge	Lcpy_3_lp
 
-cpy_2_lp:	adds	r2, r2, #8
-		blt	no_double_words
+Lcpy_2_lp:	adds	r2, r2, #8
+		blt	Lno_double_words
 		subs	r2, r2, #4
 		ldrlt	r3, [r1], #4
 		strltt	r3, [r0], #4
@@ -138,7 +138,7 @@
 		strget	r4, [r0], #4
 		subge	r2, r2, #4
 
-no_double_words:
+Lno_double_words:
 		adds	r2, r2, #4
 		EXITEQ
 		cmp	r2, #2
@@ -149,7 +149,7 @@
 		ldrgtb	r3, [r1], #1
 		strgtbt	r3, [r0], #1
 		EXIT
-dest_not_aligned:
+Ldest_not_aligned:
 		rsb	ip, ip, #4
 		cmp	ip, #2
 		ldrb	r3, [r1], #1
@@ -159,20 +159,20 @@
 		ldrgtb	r3, [r1], #1
 		strgtbt	r3, [r0], #1
 		subs	r2, r2, ip
-		blt	no_double_words
+		blt	Lno_double_words
 		ands	ip, r1, #3
-		beq	rest
-src_not_aligned:
+		beq	Lrest
+Lsrc_not_aligned:
 		bic	r1, r1, #3
 		ldr	r7, [r1], #4
 		cmp	ip, #2
-		bgt	cpy_4_3
-		beq	cpy_4_2
+		bgt	Lcpy_4_3
+		beq	Lcpy_4_2
 		cmp	r2, #12
-		blt	cpy_x_1_lp
+		blt	Lcpy_x_1_lp
 		sub	r2, r2, #12
 
-cpy_4_1_lp:	mov	r3, r7, lsr #8
+Lcpy_4_1_lp:	mov	r3, r7, lsr #8
 		ldmia	r1!, {r4 - r7}
 		orr	r3, r3, r4, lsl #24
 		mov	r4, r4, lsr #8
@@ -186,25 +186,25 @@
 		strt	r5, [r0], #4
 		strt	r6, [r0], #4
 		subs	r2, r2, #16
-		bge	cpy_4_1_lp
+		bge	Lcpy_4_1_lp
 		adds	r2,r2,#12
-		blt	rest1
+		blt	Lrest1
 
-cpy_x_1_lp:	mov	r3, r7, lsr #8
+Lcpy_x_1_lp:	mov	r3, r7, lsr #8
 		ldr	r7, [r1], #4
 		orr	r3, r3, r7, lsl #24
 		strt	r3, [r0], #4
 		subs	r2, r2, #4
-		bge	cpy_x_1_lp
+		bge	Lcpy_x_1_lp
 
-rest1:		sub	r1, r1, #3
-		b	no_double_words
+Lrest1:		sub	r1, r1, #3
+		b	Lno_double_words
 
-cpy_4_2:	cmp	r2, #12
-		blt	cpy_x_2_lp
+Lcpy_4_2:	cmp	r2, #12
+		blt	Lcpy_x_2_lp
 		sub	r2, r2, #12
 
-cpy_4_2_lp:	mov	r3, r7, lsr #16
+Lcpy_4_2_lp:	mov	r3, r7, lsr #16
 		ldmia	r1!, {r4 - r7}
 		orr	r3, r3, r4, lsl #16
 		mov	r4, r4, lsr #16
@@ -218,25 +218,25 @@
 		strt	r5, [r0], #4
 		strt	r6, [r0], #4
 		subs	r2, r2, #16
-		bge	cpy_4_2_lp
+		bge	Lcpy_4_2_lp
 		adds	r2, r2, #12
-		blt	rest2
+		blt	Lrest2
 
-cpy_x_2_lp:	mov	r3, r7, lsr #16
+Lcpy_x_2_lp:	mov	r3, r7, lsr #16
 		ldr	r7, [r1], #4
 		orr	r3, r3, r7, lsl #16
 		strt	r3, [r0], #4
 		subs	r2, r2, #4
-		bge	cpy_x_2_lp
+		bge	Lcpy_x_2_lp
 
-rest2:		sub	r1, r1, #2
-		b	no_double_words
+Lrest2:		sub	r1, r1, #2
+		b	Lno_double_words
 
-cpy_4_3:	cmp	r2, #12
-		blt	cpy_x_3_lp
+Lcpy_4_3:	cmp	r2, #12
+		blt	Lcpy_x_3_lp
 		sub	r2, r2, #12
 
-cpy_4_3_lp:	mov	r3, r7, lsr #24
+Lcpy_4_3_lp:	mov	r3, r7, lsr #24
 		ldmia	r1!, {r4 - r7}
 		orr	r3, r3, r4, lsl #8
 		mov	r4, r4, lsr #24
@@ -250,19 +250,19 @@
 		strt	r5, [r0], #4
 		strt	r6, [r0], #4
 		subs	r2, r2, #16
-		bge	cpy_4_3_lp
+		bge	Lcpy_4_3_lp
 		adds	r2, r2, #12
-		blt	rest3
+		blt	Lrest3
 
-cpy_x_3_lp:	mov	r3, r7, lsr #24
+Lcpy_x_3_lp:	mov	r3, r7, lsr #24
 		ldr	r7, [r1], #4
 		orr	r3, r3, r7, lsl #8
 		strt	r3, [r0], #4
 		subs	r2, r2, #4
-		bge	cpy_x_3_lp
+		bge	Lcpy_x_3_lp
 
-rest3:		sub	r1, r1, #1
-		b	no_double_words
+Lrest3:		sub	r1, r1, #1
+		b	Lno_double_words
 
 # Prototype: void memcpy_fromfs(void *to,const void *from,unsigned long n);
 # ARM3: cant use memcopy here!!!
@@ -275,37 +275,37 @@
 _memcpy_fromfs:
 		ENTER
 		cmp	r1, r0
-		bcc	other_copy
+		bcc	Lother_copy
 		subs	r2, r2, #4
-		blt	up_no_double_words
+		blt	Lup_no_double_words
 		ands	ip, r0, #3
-		bne	up_dest_not_aligned
+		bne	Lup_dest_not_aligned
 		ands	ip, r1, #3
-		bne	up_src_not_aligned
+		bne	Lup_src_not_aligned
 
-up_rest:	subs	r2, r2, #8
-		blt	up_cpy_2_lp
+Lup_rest:	subs	r2, r2, #8
+		blt	Lup_cpy_2_lp
 		subs	r2, r2, #0x14
-		blt	up_not_long_copy
+		blt	Lup_not_long_copy
 
-up_cpy_8_lp:	ldmia	r1!,{r3 - r9, ip}
+Lup_cpy_8_lp:	ldmia	r1!,{r3 - r9, ip}
 		stmia	r0!,{r3 - r9, ip}
 		subs	r2, r2, #32
-		bge	up_cpy_8_lp
+		bge	Lup_cpy_8_lp
 		cmn	r2, #16
 		ldmgeia	r1!, {r3 - r6}
 		stmgeia	r0!, {r3 - r6}
 		subge	r2, r2, #0x10
-up_not_long_copy:
+Lup_not_long_copy:
 		adds	r2, r2, #0x14
 
-up_cpy_3_lp:	ldmgeia	r1!, {r3 - r5}
+Lup_cpy_3_lp:	ldmgeia	r1!, {r3 - r5}
 		stmgeia	r0!, {r3 - r5}
 		subges	r2, r2, #12
-		bge	up_cpy_3_lp
+		bge	Lup_cpy_3_lp
 
-up_cpy_2_lp:	adds	r2, r2, #8
-		blt	up_no_double_words
+Lup_cpy_2_lp:	adds	r2, r2, #8
+		blt	Lup_no_double_words
 		subs	r2, r2, #4
 		ldrlt	r3, [r1], #4
 		strlt	r3, [r0], #4
@@ -313,7 +313,7 @@
 		stmgeia	r0!, {r3, r4}
 		subge	r2, r2, #4
 
-up_no_double_words:
+Lup_no_double_words:
 		adds	r2, r2, #4
 		EXITEQ
 		cmp	r2, #2
@@ -324,7 +324,7 @@
 		ldrgtb	r3, [r1], #1
 		strgtb	r3, [r0], #1
 		EXIT
-up_dest_not_aligned:
+Lup_dest_not_aligned:
 		rsb	ip, ip, #4
 		cmp	ip, #2
 		ldrb	r3, [r1], #1
@@ -334,20 +334,20 @@
 		ldrgtb	r3, [r1], #1
 		strgtb	r3, [r0], #1
 		subs	r2, r2, ip
-		blt	up_no_double_words
+		blt	Lup_no_double_words
 		ands	ip, r1, #3
-		beq	up_rest
-up_src_not_aligned:
+		beq	Lup_rest
+Lup_src_not_aligned:
 		bic	r1, r1, #3
 		ldr	r7, [r1], #4
 		cmp	ip, #2
-		bgt	up_cpy_4_3
-		beq	up_cpy_4_2
+		bgt	Lup_cpy_4_3
+		beq	Lup_cpy_4_2
 		cmp	r2, #12
-		blt	up_cpy_x_1_lp
+		blt	Lup_cpy_x_1_lp
 		sub	r2, r2, #12
 
-up_cpy_4_1_lp:	mov	r3, r7, lsr #8
+Lup_cpy_4_1_lp:	mov	r3, r7, lsr #8
 		ldmia	r1!, {r4 - r7}
 		orr	r3, r3, r4, lsl #24
 		mov	r4, r4, lsr #8
@@ -358,25 +358,25 @@
 		orr	r6, r6, r7, lsl #24
 		stmia	r0!, {r3 - r6}
 		subs	r2, r2, #16
-		bge	up_cpy_4_1_lp
+		bge	Lup_cpy_4_1_lp
 		adds	r2, r2, #12
-		blt	up_rest1
+		blt	Lup_rest1
 
-up_cpy_x_1_lp:	mov	r3, r7, lsr #8
+Lup_cpy_x_1_lp:	mov	r3, r7, lsr #8
 		ldr	r7, [r1], #4
 		orr	r3, r3, r7, lsl #24
 		str	r3, [r0], #4
 		subs	r2, r2, #4
-		bge	up_cpy_x_1_lp
+		bge	Lup_cpy_x_1_lp
 
-up_rest1:	sub	r1, r1, #3
-		b	up_no_double_words
+Lup_rest1:	sub	r1, r1, #3
+		b	Lup_no_double_words
 
-up_cpy_4_2:	cmp	r2, #12
-		blt	up_cpy_x_2_lp
+Lup_cpy_4_2:	cmp	r2, #12
+		blt	Lup_cpy_x_2_lp
 		sub	r2, r2, #12
 
-up_cpy_4_2_lp:	mov	r3, r7, lsr #16
+Lup_cpy_4_2_lp:	mov	r3, r7, lsr #16
 		ldmia	r1!, {r4 - r7}
 		orr	r3, r3, r4, lsl #16
 		mov	r4, r4, lsr #16
@@ -387,25 +387,25 @@
 		orr	r6, r6, r7,LSL#16
 		stmia	r0!, {r3 - r6}
 		subs	r2, r2, #16
-		bge	up_cpy_4_2_lp
+		bge	Lup_cpy_4_2_lp
 		adds	r2, r2, #12
-		blt	up_rest2
+		blt	Lup_rest2
 
-up_cpy_x_2_lp:	mov	r3, r7, lsr #16
+Lup_cpy_x_2_lp:	mov	r3, r7, lsr #16
 		ldr	r7, [r1], #4
 		orr	r3, r3, r7, lsl #16
 		str	r3, [r0], #4
 		subs	r2, r2, #4
-		bge	up_cpy_x_2_lp
+		bge	Lup_cpy_x_2_lp
 
-up_rest2:	sub	r1, r1, #2
-		b	up_no_double_words
+Lup_rest2:	sub	r1, r1, #2
+		b	Lup_no_double_words
 
-up_cpy_4_3:	cmp	r2, #12
-		blt	up_cpy_x_3_lp
+Lup_cpy_4_3:	cmp	r2, #12
+		blt	Lup_cpy_x_3_lp
 		sub	r2, r2, #12
 
-up_cpy_4_3_lp:	mov	r3, r7, lsr #24
+Lup_cpy_4_3_lp:	mov	r3, r7, lsr #24
 		ldmia	r1!,{r4 - r7}
 		orr	r3, r3, r4, lsl #8
 		mov	r4, r4, lsr #24
@@ -416,42 +416,42 @@
 		orr	r6, r6, r7, lsl #8
 		stmia	r0!, {r3 - r6}
 		subs	r2, r2, #16
-		bge	up_cpy_4_3_lp
+		bge	Lup_cpy_4_3_lp
 		adds	r2, r2, #12
-		blt	up_rest3
+		blt	Lup_rest3
 
-up_cpy_x_3_lp:	mov	r3, r7, lsr #24
+Lup_cpy_x_3_lp:	mov	r3, r7, lsr #24
 		ldr	r7, [r1], #4
 		orr	r3, r3, r7, lsl#8
 		str	r3, [r0], #4
 		subs	r2, r2, #4
-		bge	up_cpy_x_3_lp
+		bge	Lup_cpy_x_3_lp
 
-up_rest3:	sub	r1, r1, #1
-		b	up_no_double_words
+Lup_rest3:	sub	r1, r1, #1
+		b	Lup_no_double_words
 
 
-other_copy:	add	r1, r1, r2
+Lother_copy:	add	r1, r1, r2
 		add	r0, r0, r2
 		subs	r2, r2, #4
-		blt	down_no_double_words
+		blt	Ldown_no_double_words
 		ands	ip, r0, #3
-		bne	down_dest_not_aligned
+		bne	Ldown_dest_not_aligned
 		ands	ip, r1, #3
-		bne	down_src_not_aligned
+		bne	Ldown_src_not_aligned
 
-down_rest:
+Ldown_rest:
 		subs	r2, r2, #8
-		blt	down_cpy_2_lp
+		blt	Ldown_cpy_2_lp
 		subs	r2, r2, #0x14
-		blt	down_not_long_copy
-down_cpy_8_lp:
+		blt	Ldown_not_long_copy
+Ldown_cpy_8_lp:
 		ldmdb	r1!, {r3 - r9, ip}
 		stmdb	r0!, {r3 - r9, ip}
 		subs	r2, r2, #32
-		bge	down_cpy_8_lp
+		bge	Ldown_cpy_8_lp
 
-down_not_long_copy:
+Ldown_not_long_copy:
 		cmn	r2, #16
 		ldmgedb	r1!, {r3 - r6}
 		stmgedb	r0!, {r3 - r6}
@@ -460,9 +460,9 @@
 		ldmgedb	r1!, {r3 - r5}
 		stmgedb	r0!, {r3 - r5}
 		subge	r2, r2, #12
-down_cpy_2_lp:
+Ldown_cpy_2_lp:
 		adds	r2, r2, #8
-		blt	down_no_double_words
+		blt	Ldown_no_double_words
 		subs	r2, r2, #4
 		ldrlt	r3, [r1, #-4]!
 		strlt	r3, [r0, #-4]!
@@ -470,7 +470,7 @@
 		stmgedb	r0!, {r3, r4}
 		subge	r2, r2, #4
 
-down_no_double_words:
+Ldown_no_double_words:
 		adds	r2, r2, #4
 		EXITEQ
 		cmp	r2, #2
@@ -482,7 +482,7 @@
 		strgtb	r3, [r0, #-1]!
 		EXIT
 
-down_dest_not_aligned:
+Ldown_dest_not_aligned:
 		CMP	ip,#2
 		LDRB	r3,[r1,#-1]!
 		STRB	r3,[r0,#-1]!
@@ -491,21 +491,21 @@
 		LDRGTB	r3,[r1,#-1]!
 		STRGTB	r3,[r0,#-1]!
 		SUBS	r2,r2,ip
-		BLT	down_no_double_words
+		BLT	Ldown_no_double_words
 		ANDS	ip,r1,#3
-		BEQ	down_rest
+		BEQ	Ldown_rest
 
-down_src_not_aligned:
+Ldown_src_not_aligned:
 		BIC	r1,r1,#3
 		LDR	r3,[r1],#0
 		CMP	ip,#2
-		BLT	down_cpy_4_3
-		BEQ	down_cpy_4_2
+		BLT	Ldown_cpy_4_3
+		BEQ	Ldown_cpy_4_2
 		CMP	r2,#12
-		BLT	down_cpy_x_1_lp
+		BLT	Ldown_cpy_x_1_lp
 		SUB	r2,r2,#12
 
-down_cpy_4_1_lp:
+Ldown_cpy_4_1_lp:
 		MOV	r7,r3,LSL#8
 		LDMDB	r1!,{r3,r4,r5,r6}
 		ORR	r7,r7,r6,LSR#24
@@ -517,28 +517,28 @@
 		ORR	r4,r4,r3,LSR#24
 		STMDB	r0!,{r4,r5,r6,r7}
 		SUBS	r2,r2,#16
-		BGE	down_cpy_4_1_lp
+		BGE	Ldown_cpy_4_1_lp
 		ADDS	r2,r2,#12
-		BLT	down_rest1
+		BLT	Ldown_rest1
 
-down_cpy_x_1_lp:
+Ldown_cpy_x_1_lp:
 		MOV	ip,r3,LSL#8
 		LDR	r3,[r1,#-4]!
 		ORR	ip,ip,r3,LSR#24
 		STR	ip,[r0,#-4]!
 		SUBS	r2,r2,#4
-		BGE	down_cpy_x_1_lp
+		BGE	Ldown_cpy_x_1_lp
 
-down_rest1:
+Ldown_rest1:
 		ADD	r1,r1,#3
-		B	down_no_double_words
+		B	Ldown_no_double_words
 
-down_cpy_4_2:
+Ldown_cpy_4_2:
 		CMP	r2,#12
-		BLT	down_cpy_x_2_lp
+		BLT	Ldown_cpy_x_2_lp
 		SUB	r2,r2,#12
 
-down_cpy_4_2_lp:
+Ldown_cpy_4_2_lp:
 		MOV	r7,r3,LSL#16
 		LDMDB	r1!,{r3,r4,r5,r6}
 		ORR	r7,r7,r6,LSR#16
@@ -550,28 +550,28 @@
 		ORR	r4,r4,r3,LSR#16
 		STMDB	r0!,{r4,r5,r6,r7}
 		SUBS	r2,r2,#16
-		BGE	down_cpy_4_2_lp
+		BGE	Ldown_cpy_4_2_lp
 		ADDS	r2,r2,#12
-		BLT	down_rest2
+		BLT	Ldown_rest2
 
-down_cpy_x_2_lp:
+Ldown_cpy_x_2_lp:
 		MOV	ip,r3,LSL#16
 		LDR	r3,[r1,#-4]!
 		ORR	ip,ip,r3,LSR#16
 		STR	ip,[r0,#-4]!
 		SUBS	r2,r2,#4
-		BGE	down_cpy_x_2_lp
+		BGE	Ldown_cpy_x_2_lp
 
-down_rest2:
+Ldown_rest2:
 		ADD	r1,r1,#2
-		B	down_no_double_words
+		B	Ldown_no_double_words
 
-down_cpy_4_3:
+Ldown_cpy_4_3:
 		CMP	r2,#12
-		BLT	down_cpy_x_3_lp
+		BLT	Ldown_cpy_x_3_lp
 		SUB	r2,r2,#12
 
-down_cpy_4_3_lp:
+Ldown_cpy_4_3_lp:
 		MOV	r7,r3,LSL#24
 		LDMDB	r1!,{r3,r4,r5,r6}
 		ORR	r7,r7,r6,LSR#8
@@ -583,17 +583,17 @@
 		ORR	r4,r4,r3,LSR#8
 		STMDB	r0!,{r4,r5,r6,r7}
 		SUBS	r2,r2,#16
-		BGE	down_cpy_4_3_lp
+		BGE	Ldown_cpy_4_3_lp
 		ADDS	r2,r2,#12
-		BLT	down_rest3
-down_cpy_x_3_lp:
+		BLT	Ldown_rest3
+Ldown_cpy_x_3_lp:
 		MOV	ip,r3,LSL#24
 		LDR	r3,[r1,#-4]!
 		ORR	ip,ip,r3,LSR#8
 		STR	ip,[r0,#-4]!
 		SUBS	r2,r2,#4
-		BGE	down_cpy_x_3_lp
-down_rest3:
+		BGE	Ldown_cpy_x_3_lp
+Ldown_rest3:
 		ADD	r1,r1,#1
-		B	down_no_double_words
+		B	Ldown_no_double_words
 
diff -urN linux.store/linux/arch/arm/lib/string.S linux/arch/arm/lib/string.S
--- linux.store/linux/arch/arm/lib/string.S	Sun Mar  3 13:17:16 1996
+++ linux/arch/arm/lib/string.S	Thu Mar 28 10:23:15 1996
@@ -11,11 +11,11 @@
 		.global	_strrchr
 _strrchr:	stmfd	sp!,{lr}
 		mov	r3,#0
-strrchrlp:	ldrb	r2,[r0],#1
+Lstrrchrlp:	ldrb	r2,[r0],#1
 		teq	r2,r1
 		moveq	r3,r0
 		teq	r2,#0
-		bne	strrchrlp
+		bne	Lstrrchrlp
 		mov	r0,r3
 		LOADREGS(fd, sp!, {pc})
 
@@ -25,20 +25,20 @@
 		stmfd	sp!, {lr}
 		mov	r3, r0
 		cmp	r2, #4
-		blt	memsetlp
+		blt	Lmemsetlp
 		ands	ip, r3, #3
-		beq	aligned
+		beq	Laligned
 		cmp	ip, #2
 		strltb	r1, [r3], #1
 		strleb	r1, [r3], #1
 		strb	r1, [r3], #1
 		rsb	ip, ip, #4
 		sub	r2, r2, ip
-aligned:	orr	ip, r1, r1, lsl #8
+Laligned:	orr	ip, r1, r1, lsl #8
 		orr	ip, ip, ip, lsl #16
 		subs	r2, r2, #32
-		bmi	memsetl32
-memset32lp:	str	ip, [r3], #4
+		bmi	Lmemsetl32
+Lmemset32lp:	str	ip, [r3], #4
 		str	ip, [r3], #4
 		str	ip, [r3], #4
 		str	ip, [r3], #4
@@ -48,29 +48,29 @@
 		str	ip, [r3], #4
 		LOADREGS(eqfd, sp!, {pc})
 		subs	r2, r2, #32
-		bpl	memset32lp
-memsetl32:	adds	r2, r2, #16
-		bmi	memsetl16
+		bpl	Lmemset32lp
+Lmemsetl32:	adds	r2, r2, #16
+		bmi	Lmemsetl16
 		str	ip, [r3], #4
 		str	ip, [r3], #4
 		str	ip, [r3], #4
 		str	ip, [r3], #4
 		LOADREGS(eqfd, sp!, {pc})
 		sub	r2, r2, #16
-memsetl16:	adds	r2, r2, #8
-		bmi	memsetl8
+Lmemsetl16:	adds	r2, r2, #8
+		bmi	Lmemsetl8
 		str	ip, [r3], #4
 		str	ip, [r3], #4
 		LOADREGS(eqfd, sp!, {pc})
 		sub	r2, r2, #8
-memsetl8:	adds	r2, r2, #4
-		bmi	memsetl4
+Lmemsetl8:	adds	r2, r2, #4
+		bmi	Lmemsetl4
 		str	ip, [r3], #4
 		LOADREGS(eqfd, sp!, {pc})
 		sub	r2, r2, #4
-memsetl4:	add	r2, r2, #4
-memsetlp:	subs	r2, r2, #1
+Lmemsetl4:	add	r2, r2, #4
+Lmemsetlp:	subs	r2, r2, #1
 		strgeb	r1, [r3], #1
-		bgt	memsetlp
+		bgt	Lmemsetlp
 		LOADREGS(fd, sp!, {pc})
 
diff -urN linux.store/linux/arch/arm/lib/system.S linux/arch/arm/lib/system.S
--- linux.store/linux/arch/arm/lib/system.S	Sun Mar  3 13:17:43 1996
+++ linux/arch/arm/lib/system.S	Thu Mar 28 10:25:18 1996
@@ -33,7 +33,7 @@
 LC0:
 		.word	_current
 LC1:
-		.word	_wantmap
+		.word	Lwantmap
 LC2:
 		.word	_page_nr
 LC3:
@@ -88,7 +88,7 @@
 		orr	r3, r3, #0x03F00000
 		ldr	r2, [pc, #LC2 - . - 8]
 		ldr	r2, [r2]
-removelp:	subs	r2, r2, #1
+Lremovelp:	subs	r2, r2, #1
 		orrpl	r1, r3, r2
 		strpl	r1, [r4, r2, lsl#2]
 		subpls	r2, r2, #1
@@ -100,52 +100,52 @@
 		subpls	r2, r2, #1
 		orrpl	r1, r3, r2
 		strpl	r1, [r4, r2, lsl#2]
-		bpl	removelp
+		bpl	Lremovelp
 
-		adr	r6, phystomemc32	@ Convert to logical page number
+		adr	r6, Lphystomemc32	@ Convert to logical page number
 		ldr	r1, [pc, #LC3 - . - 8]
 		ldr	r7, [r1]
 		mov	r1, #32*1024*1024	@ Top of logical memory
 		mov	r1, r1, LSR r7		@ Convert to logical page number
 		sub	r8, r1, #1		@ Max. logical page no.
 
-invalidatelp:	ldr	r1, [r0, r8, lsl#2]	@ Get map info
+Linvalidatelp:	ldr	r1, [r0, r8, lsl#2]	@ Get map info
 		tst	r1, #PAGE_PRESENT	@ Check to see if it is present
-		beq	nextpage		@ If not, try next
+		beq	Lnextpage		@ If not, try next
 		mov	r2, r1, lsr r7		@ convert entry to physical page number
 		and	r2, r2, #0xff		@ Ensure that we only have the page no.
 		ldr	r2, [r6, r2, lsl#2]	@ Convert to memc page number
 		tst	r1, #PAGE_ACCESSED	@ check accessed
 		tstne	r1, #PAGE_USER
-		beq	not_accessed
+		beq	Lnot_accessed
 		bic	r2, r2, #0x200
 		tst	r1, #PAGE_RW
 		tstne	r1,#PAGE_DIRTY
 		bicne	r2, r2, #0x300		@ Read/Write
 
-not_accessed:	mov	r1, r8, lsl r7		@ Shift logical page into correct position
+Lnot_accessed:	mov	r1, r8, lsl r7		@ Shift logical page into correct position
 		mov	r3, r1, lsl #9		@ get low bits of page number
 		orr	r2, r2, r3, lsr #9
 		and	r1, r1, #0x01800000
 		orr	r2, r2, r1, lsr #(23 - 10)
 		and	r1, r2, #255
 		str	r2, [r4, r1, lsl #2]	@ save in 'wanted' map table
-nextpage:	subs	r8,r8,#1
-		bpl	invalidatelp
+Lnextpage:	subs	r8,r8,#1
+		bpl	Linvalidatelp
 
-@ update the map to 'wantmap' - wantmap is in r11, r10 = page_nr
+@ update the map to 'Lwantmap' - wantmap is in r11, r10 = page_nr
 @ (interrupts can be enabled, and will be soon...)
-map_update:	ldr	r3, [pc, #LC2 - . - 8]
+Lmap_update:	ldr	r3, [pc, #LC2 - . - 8]
 		ldr	r3, [r3]
 		sub	r3, r3, #1
 		ldr	r5, [pc, #LC4 - . - 8]
-map_updatelp:	ldr	r1, [r4,r3,LSL#2]
+Lmap_updatelp:	ldr	r1, [r4,r3,LSL#2]
 		ldr	r2, [r5,r3,LSL#2]
 		teq	r2, r1
 		strne	r1, [r5,r3,LSL#2]
 		strneb	r1,[r1]
 		subs	r3,r3,#1
-		bpl	map_updatelp
+		bpl	Lmap_updatelp
 		ldmea	fp, {r4 - r9, fp, sp, pc}^
 
 		.align
@@ -169,7 +169,7 @@
 		.word	af | 0x03800300
 
 @ Table to map from page number to vidc page number
-phystomemc32:
+Lphystomemc32:
 		
 		PCD(	0x00,0x08,0x10,0x18,0x20,0x28,0x30,0x38,0x40,0x48,0x50,0x58,0x60,0x68,0x70,0x78)
 		PCD(	0x01,0x09,0x11,0x19,0x21,0x29,0x31,0x39,0x41,0x49,0x51,0x59,0x61,0x69,0x71,0x79)
@@ -209,7 +209,7 @@
 		.word	-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1
 		.word	-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1
 # The wanted memc mapping
-_wantmap:
+Lwantmap:
 		.word	-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1
 		.word	-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1
 		.word	-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1
